<script lang="ts">
    import { SgExport } from '../domain/sg-export';
    import Chart from 'chart.js/auto';

    let fileInput: HTMLInputElement;
    let chartCanvas: HTMLCanvasElement;
    let currentAmount: number;
    let isFileUploaded: boolean = false;
    let fromDate: string = '';
    let toDate: string = '';
    let totalAmounts: any[];
    let myChart;

    function openUpload() {
        fileInput.click();
    }

    function handleUpload() {
        const file: File = fileInput.files[0];

        const reader = new FileReader();
        reader.onload = (event: ProgressEvent<FileReader>) => {
            const target: { result: string } = event.currentTarget as any;
            const data: string = target.result;
            const csv = atob(data.replace('data:text/csv;base64,', ''));

            submit(csv);
        };
        reader.readAsDataURL(file);
    }

    function submit(csv: string) {
        isFileUploaded = true;
        const sgExport = new SgExport(csv);
        totalAmounts = sgExport.computeCurrentAmount(currentAmount || 0);
        fromDate = totalAmounts.at(0).date;
        toDate = totalAmounts.at(-1).date;
        showChart();
    }

    function showChart() {
        const filteredTotalAmounts = totalAmounts
            .filter(i => i.date >= fromDate)
            .filter(i => i.date <= toDate);

        const ctx: CanvasRenderingContext2D = chartCanvas.getContext('2d');

        const footer = (tooltipItems: any[]) => {
            const selectedItem = filteredTotalAmounts.find(i => i.date === tooltipItems[0].label);
            return selectedItem.operations
                .map(o => o.amount + ' €: ' + o.label)
                .join('\n') + '\n' +
                'Total: ' + selectedItem.amount + ' €\n' +
                'Solde: ' + selectedItem.total + ' €';
        };

        if (myChart) {
            myChart.destroy();
        }
        myChart = new Chart(ctx, {
            type: 'line',
            data: {
                labels: filteredTotalAmounts.map(i => i.date),
                datasets: [{
                    label: 'Dataset 1',
                    data: filteredTotalAmounts.map(i => i.total),
                    borderColor: 'rgba(255, 99, 132, 0.2)',
                    backgroundColor: 'rgba(255, 99, 132, 1)',
                }]
            },
            options: {
                plugins: {
                    tooltip: {
                        callbacks: {
                            footer: footer,
                        }
                    }
                }
            }
        });

    }
</script>

<style lang="scss">
  .hidden {
    display: none !important;
  }

  .chart {
    height: 300px;
    width: 100%;
  }

  .zone {
    width: 100%;
    height: 100px;
    border: 3px dashed green;
    display: flex;
    align-items: center;
    justify-content: center;
    color: green;
    font-weight: bold;
    cursor: pointer;
    border-radius: 10px;

    input[type=file] {
      display: none;
    }
  }
</style>

<div class="columns">
    <div>
        <label class="label">Solde actuel</label>
        <div class="field has-addons">
            <p class="control">
                <input class="input" bind:value={currentAmount} type="number" placeholder="Ex: 130">
            </p>
            <p class="control">
                <a class="button is-static">
                    €
                </a>
            </p>
        </div>
    </div>
    {#if isFileUploaded}
        <div>
            <label class="label">Depuis</label>
            <div class="field">
                <div class="control">
                    <div class="select">
                        <select bind:value={fromDate} on:change={() => showChart()}>
                            {#each totalAmounts.map(i => i.date) as date}
                                <option value={date}>{date}</option>
                            {/each}
                        </select>
                    </div>
                </div>
            </div>
        </div>
        <div>
            <label class="label">Jusqu'à</label>
            <div class="field">
                <div class="control">
                    <div class="select">
                        <select bind:value={toDate} on:change={() => showChart()}>
                            {#each totalAmounts.map(i => i.date) as date}
                                <option value={date}>{date}</option>
                            {/each}
                        </select>
                    </div>
                </div>
            </div>
        </div>
    {/if}
</div>

<div class="zone" on:click={() => openUpload()} class:hidden={isFileUploaded}>
    Charger un fichier
    <input type="file" bind:this={fileInput} on:change={() => handleUpload()}>
</div>
<div class="chart" class:hidden={!isFileUploaded}>
    <canvas bind:this={chartCanvas} id="myChart"></canvas>
</div>

